<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "https://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=9"/>
<meta name="generator" content="Doxygen 1.8.16"/>
<meta name="viewport" content="width=device-width, initial-scale=1"/>
<title>Zonzay: setup_hashed_features_abstract.h Source File</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="jquery.js"></script>
<script type="text/javascript" src="dynsections.js"></script>
<link href="search/search.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="search/searchdata.js"></script>
<script type="text/javascript" src="search/search.js"></script>
<link href="doxygen.css" rel="stylesheet" type="text/css" />
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr style="height: 56px;">
  <td id="projectlogo"><img alt="Logo" src="zonzay.png"/></td>
  <td id="projectalign" style="padding-left: 0.5em;">
   <div id="projectname">Zonzay
   &#160;<span id="projectnumber">1</span>
   </div>
   <div id="projectbrief">Laugh game challenge</div>
  </td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- Generated by Doxygen 1.8.16 -->
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
var searchBox = new SearchBox("searchBox", "search",false,'Search');
/* @license-end */
</script>
<script type="text/javascript" src="menudata.js"></script>
<script type="text/javascript" src="menu.js"></script>
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
$(function() {
  initMenu('',true,false,'search.php','Search');
  $(document).ready(function() { init_search(); });
});
/* @license-end */</script>
<div id="main-nav"></div>
<!-- window showing the filter options -->
<div id="MSearchSelectWindow"
     onmouseover="return searchBox.OnSearchSelectShow()"
     onmouseout="return searchBox.OnSearchSelectHide()"
     onkeydown="return searchBox.OnSearchSelectKey(event)">
</div>

<!-- iframe showing the search results (closed by default) -->
<div id="MSearchResultsWindow">
<iframe src="javascript:void(0)" frameborder="0" 
        name="MSearchResults" id="MSearchResults">
</iframe>
</div>

<div id="nav-path" class="navpath">
  <ul>
<li class="navelem"><a class="el" href="dir_f6486992fdfcc735347cc2d407578037.html">FaceFilterSDK</a></li><li class="navelem"><a class="el" href="dir_80a4fd4d67846ee877317f9ddd7282cb.html">DlibWrapper</a></li><li class="navelem"><a class="el" href="dir_9b7b8713e4f43f3006d0cb3c779d469e.html">dlib</a></li><li class="navelem"><a class="el" href="dir_6fa195adb58ca7edc2dded7e6bc48796.html">image_processing</a></li>  </ul>
</div>
</div><!-- top -->
<div class="header">
  <div class="headertitle">
<div class="title">setup_hashed_features_abstract.h</div>  </div>
</div><!--header-->
<div class="contents">
<div class="fragment"><div class="line"><a name="l00001"></a><span class="lineno">    1</span>&#160;<span class="comment">// Copyright (C) 2011  Davis E. King (davis@dlib.net)</span></div><div class="line"><a name="l00002"></a><span class="lineno">    2</span>&#160;<span class="comment">// License: Boost Software License   See LICENSE.txt for the full license.</span></div><div class="line"><a name="l00003"></a><span class="lineno">    3</span>&#160;<span class="preprocessor">#undef DLIB_SETUP_HAShED_FEATURES_ABSTRACT_Hh_</span></div><div class="line"><a name="l00004"></a><span class="lineno">    4</span>&#160;<span class="preprocessor">#ifdef DLIB_SETUP_HAShED_FEATURES_ABSTRACT_Hh_</span></div><div class="line"><a name="l00005"></a><span class="lineno">    5</span>&#160; </div><div class="line"><a name="l00006"></a><span class="lineno">    6</span>&#160;<span class="preprocessor">#include &quot;scan_image_pyramid_abstract.h&quot;</span></div><div class="line"><a name="l00007"></a><span class="lineno">    7</span>&#160;<span class="preprocessor">#include &quot;scan_image_boxes_abstract.h&quot;</span></div><div class="line"><a name="l00008"></a><span class="lineno">    8</span>&#160;<span class="preprocessor">#include &quot;../lsh/projection_hash_abstract.h&quot;</span></div><div class="line"><a name="l00009"></a><span class="lineno">    9</span>&#160;<span class="preprocessor">#include &quot;../image_keypoint/hashed_feature_image_abstract.h&quot;</span></div><div class="line"><a name="l00010"></a><span class="lineno">   10</span>&#160;<span class="preprocessor">#include &quot;../image_keypoint/binned_vector_feature_image_abstract.h&quot;</span></div><div class="line"><a name="l00011"></a><span class="lineno">   11</span>&#160; </div><div class="line"><a name="l00012"></a><span class="lineno">   12</span>&#160;<span class="keyword">namespace </span><a class="code" href="namespacedlib.html">dlib</a></div><div class="line"><a name="l00013"></a><span class="lineno">   13</span>&#160;{</div><div class="line"><a name="l00014"></a><span class="lineno">   14</span>&#160; </div><div class="line"><a name="l00015"></a><span class="lineno">   15</span>&#160;<span class="comment">// ----------------------------------------------------------------------------------------</span></div><div class="line"><a name="l00016"></a><span class="lineno">   16</span>&#160; </div><div class="line"><a name="l00017"></a><span class="lineno">   17</span>&#160;    <span class="keyword">class </span>image_hash_construction_failure : <span class="keyword">public</span> error</div><div class="line"><a name="l00018"></a><span class="lineno">   18</span>&#160;    {</div><div class="line"><a name="l00023"></a><span class="lineno">   23</span>&#160;    };</div><div class="line"><a name="l00024"></a><span class="lineno">   24</span>&#160; </div><div class="line"><a name="l00025"></a><span class="lineno">   25</span>&#160;<span class="comment">// ----------------------------------------------------------------------------------------</span></div><div class="line"><a name="l00026"></a><span class="lineno">   26</span>&#160; </div><div class="line"><a name="l00027"></a><span class="lineno">   27</span>&#160;    <span class="keyword">template</span> &lt;</div><div class="line"><a name="l00028"></a><span class="lineno">   28</span>&#160;        <span class="keyword">typename</span> image_scanner</div><div class="line"><a name="l00029"></a><span class="lineno">   29</span>&#160;        &gt;</div><div class="line"><a name="l00030"></a><span class="lineno">   30</span>&#160;    <span class="keywordtype">void</span> use_uniform_feature_weights (</div><div class="line"><a name="l00031"></a><span class="lineno">   31</span>&#160;        image_scanner&amp; scanner</div><div class="line"><a name="l00032"></a><span class="lineno">   32</span>&#160;    );</div><div class="line"><a name="l00043"></a><span class="lineno">   43</span>&#160;<span class="comment">// ----------------------------------------------------------------------------------------</span></div><div class="line"><a name="l00044"></a><span class="lineno">   44</span>&#160; </div><div class="line"><a name="l00045"></a><span class="lineno">   45</span>&#160;    <span class="keyword">template</span> &lt;</div><div class="line"><a name="l00046"></a><span class="lineno">   46</span>&#160;        <span class="keyword">typename</span> image_scanner</div><div class="line"><a name="l00047"></a><span class="lineno">   47</span>&#160;        &gt;</div><div class="line"><a name="l00048"></a><span class="lineno">   48</span>&#160;    <span class="keywordtype">void</span> use_relative_feature_weights (</div><div class="line"><a name="l00049"></a><span class="lineno">   49</span>&#160;        image_scanner&amp; scanner</div><div class="line"><a name="l00050"></a><span class="lineno">   50</span>&#160;    );</div><div class="line"><a name="l00061"></a><span class="lineno">   61</span>&#160;<span class="comment">// ----------------------------------------------------------------------------------------</span></div><div class="line"><a name="l00062"></a><span class="lineno">   62</span>&#160; </div><div class="line"><a name="l00063"></a><span class="lineno">   63</span>&#160;    <span class="keyword">template</span> &lt;</div><div class="line"><a name="l00064"></a><span class="lineno">   64</span>&#160;        <span class="keyword">typename</span> image_array,</div><div class="line"><a name="l00065"></a><span class="lineno">   65</span>&#160;        <span class="keyword">typename</span> pyramid,</div><div class="line"><a name="l00066"></a><span class="lineno">   66</span>&#160;        <span class="keyword">typename</span> feature_extractor</div><div class="line"><a name="l00067"></a><span class="lineno">   67</span>&#160;        <span class="keyword">template</span> &lt;<span class="keyword">typename</span> fe, <span class="keyword">typename</span> hash&gt; <span class="keyword">class </span>feature_image</div><div class="line"><a name="l00068"></a><span class="lineno">   68</span>&#160;        &gt;</div><div class="line"><a name="l00069"></a><span class="lineno">   69</span>&#160;    <span class="keywordtype">void</span> setup_hashed_features (</div><div class="line"><a name="l00070"></a><span class="lineno">   70</span>&#160;        scan_image_pyramid&lt;pyramid, feature_image&lt;feature_extractor, projection_hash&gt; &gt;&amp; scanner,</div><div class="line"><a name="l00071"></a><span class="lineno">   71</span>&#160;        <span class="keyword">const</span> image_array&amp; images,</div><div class="line"><a name="l00072"></a><span class="lineno">   72</span>&#160;        <span class="keyword">const</span> feature_extractor&amp; fe,</div><div class="line"><a name="l00073"></a><span class="lineno">   73</span>&#160;        <span class="keywordtype">int</span> bits,</div><div class="line"><a name="l00074"></a><span class="lineno">   74</span>&#160;        <span class="keywordtype">unsigned</span> <span class="keywordtype">long</span> num_samples = 200000</div><div class="line"><a name="l00075"></a><span class="lineno">   75</span>&#160;    );</div><div class="line"><a name="l00099"></a><span class="lineno">   99</span>&#160;<span class="comment">// ----------------------------------------------------------------------------------------</span></div><div class="line"><a name="l00100"></a><span class="lineno">  100</span>&#160; </div><div class="line"><a name="l00101"></a><span class="lineno">  101</span>&#160;    <span class="keyword">template</span> &lt;</div><div class="line"><a name="l00102"></a><span class="lineno">  102</span>&#160;        <span class="keyword">typename</span> image_array,</div><div class="line"><a name="l00103"></a><span class="lineno">  103</span>&#160;        <span class="keyword">typename</span> pyramid,</div><div class="line"><a name="l00104"></a><span class="lineno">  104</span>&#160;        <span class="keyword">typename</span> feature_extractor</div><div class="line"><a name="l00105"></a><span class="lineno">  105</span>&#160;        <span class="keyword">template</span> &lt;<span class="keyword">typename</span> fe, <span class="keyword">typename</span> hash&gt; <span class="keyword">class </span>feature_image</div><div class="line"><a name="l00106"></a><span class="lineno">  106</span>&#160;        &gt;</div><div class="line"><a name="l00107"></a><span class="lineno">  107</span>&#160;    <span class="keywordtype">void</span> setup_hashed_features (</div><div class="line"><a name="l00108"></a><span class="lineno">  108</span>&#160;        scan_image_pyramid&lt;pyramid, feature_image&lt;feature_extractor, projection_hash&gt; &gt;&amp; scanner,</div><div class="line"><a name="l00109"></a><span class="lineno">  109</span>&#160;        <span class="keyword">const</span> image_array&amp; images,</div><div class="line"><a name="l00110"></a><span class="lineno">  110</span>&#160;        <span class="keywordtype">int</span> bits,</div><div class="line"><a name="l00111"></a><span class="lineno">  111</span>&#160;        <span class="keywordtype">unsigned</span> <span class="keywordtype">long</span> num_samples = 200000</div><div class="line"><a name="l00112"></a><span class="lineno">  112</span>&#160;    );</div><div class="line"><a name="l00131"></a><span class="lineno">  131</span>&#160;<span class="comment">// ----------------------------------------------------------------------------------------</span></div><div class="line"><a name="l00132"></a><span class="lineno">  132</span>&#160;<span class="comment">// ----------------------------------------------------------------------------------------</span></div><div class="line"><a name="l00133"></a><span class="lineno">  133</span>&#160;<span class="comment">// ----------------------------------------------------------------------------------------</span></div><div class="line"><a name="l00134"></a><span class="lineno">  134</span>&#160;<span class="comment">// ----------------------------------------------------------------------------------------</span></div><div class="line"><a name="l00135"></a><span class="lineno">  135</span>&#160; </div><div class="line"><a name="l00136"></a><span class="lineno">  136</span>&#160;    <span class="keyword">template</span> &lt;</div><div class="line"><a name="l00137"></a><span class="lineno">  137</span>&#160;        <span class="keyword">typename</span> image_array,</div><div class="line"><a name="l00138"></a><span class="lineno">  138</span>&#160;        <span class="keyword">typename</span> feature_extractor,</div><div class="line"><a name="l00139"></a><span class="lineno">  139</span>&#160;        <span class="keyword">template</span> &lt;<span class="keyword">typename</span> fe, <span class="keyword">typename</span> hash&gt; <span class="keyword">class </span>feature_image</div><div class="line"><a name="l00140"></a><span class="lineno">  140</span>&#160;        <span class="keyword">typename</span> box_generator</div><div class="line"><a name="l00141"></a><span class="lineno">  141</span>&#160;        &gt;</div><div class="line"><a name="l00142"></a><span class="lineno">  142</span>&#160;    <span class="keywordtype">void</span> setup_hashed_features (</div><div class="line"><a name="l00143"></a><span class="lineno">  143</span>&#160;        scan_image_boxes&lt;feature_image&lt;feature_extractor, projection_hash&gt;,box_generator&gt;&amp; scanner,</div><div class="line"><a name="l00144"></a><span class="lineno">  144</span>&#160;        <span class="keyword">const</span> image_array&amp; images,</div><div class="line"><a name="l00145"></a><span class="lineno">  145</span>&#160;        <span class="keyword">const</span> feature_extractor&amp; fe,</div><div class="line"><a name="l00146"></a><span class="lineno">  146</span>&#160;        <span class="keywordtype">int</span> bits,</div><div class="line"><a name="l00147"></a><span class="lineno">  147</span>&#160;        <span class="keywordtype">unsigned</span> <span class="keywordtype">long</span> num_samples = 200000</div><div class="line"><a name="l00148"></a><span class="lineno">  148</span>&#160;    );</div><div class="line"><a name="l00172"></a><span class="lineno">  172</span>&#160;<span class="comment">// ----------------------------------------------------------------------------------------</span></div><div class="line"><a name="l00173"></a><span class="lineno">  173</span>&#160; </div><div class="line"><a name="l00174"></a><span class="lineno">  174</span>&#160;    <span class="keyword">template</span> &lt;</div><div class="line"><a name="l00175"></a><span class="lineno">  175</span>&#160;        <span class="keyword">typename</span> image_array,</div><div class="line"><a name="l00176"></a><span class="lineno">  176</span>&#160;        <span class="keyword">typename</span> feature_extractor,</div><div class="line"><a name="l00177"></a><span class="lineno">  177</span>&#160;        <span class="keyword">template</span> &lt;<span class="keyword">typename</span> fe, <span class="keyword">typename</span> hash&gt; <span class="keyword">class </span>feature_image</div><div class="line"><a name="l00178"></a><span class="lineno">  178</span>&#160;        <span class="keyword">typename</span> box_generator</div><div class="line"><a name="l00179"></a><span class="lineno">  179</span>&#160;        &gt;</div><div class="line"><a name="l00180"></a><span class="lineno">  180</span>&#160;    <span class="keywordtype">void</span> setup_hashed_features (</div><div class="line"><a name="l00181"></a><span class="lineno">  181</span>&#160;        scan_image_boxes&lt;feature_image&lt;feature_extractor, projection_hash&gt;,box_generator&gt;&amp; scanner,</div><div class="line"><a name="l00182"></a><span class="lineno">  182</span>&#160;        <span class="keyword">const</span> image_array&amp; images,</div><div class="line"><a name="l00183"></a><span class="lineno">  183</span>&#160;        <span class="keywordtype">int</span> bits,</div><div class="line"><a name="l00184"></a><span class="lineno">  184</span>&#160;        <span class="keywordtype">unsigned</span> <span class="keywordtype">long</span> num_samples = 200000</div><div class="line"><a name="l00185"></a><span class="lineno">  185</span>&#160;    );</div><div class="line"><a name="l00204"></a><span class="lineno">  204</span>&#160;<span class="comment">// ----------------------------------------------------------------------------------------</span></div><div class="line"><a name="l00205"></a><span class="lineno">  205</span>&#160; </div><div class="line"><a name="l00206"></a><span class="lineno">  206</span>&#160;}</div><div class="line"><a name="l00207"></a><span class="lineno">  207</span>&#160; </div><div class="line"><a name="l00208"></a><span class="lineno">  208</span>&#160;<span class="preprocessor">#endif // DLIB_SETUP_HAShED_FEATURES_ABSTRACT_Hh_</span></div><div class="line"><a name="l00209"></a><span class="lineno">  209</span>&#160; </div><div class="line"><a name="l00210"></a><span class="lineno">  210</span>&#160; </div></div><!-- fragment --></div><!-- contents -->
<div class="ttc" id="anamespacedlib_html"><div class="ttname"><a href="namespacedlib.html">dlib</a></div><div class="ttdef"><b>Definition:</b> algs.h:119</div></div>
<!-- start footer part -->
<hr class="footer"/><address class="footer"><small>
Generated by &#160;<a href="http://www.doxygen.org/index.html">
<img class="footer" src="doxygen.png" alt="doxygen"/>
</a> 1.8.16
</small></address>
</body>
</html>
